using System;
using System.Web.Mvc;

namespace MvcApplication3.Code
{
    public class ErrorViewResult : ViewResult
    {
        public Exception Exception { get; private set; }


        public ErrorViewResult(Exception exception)
        {
            Exception = exception;
        }

        public override void ExecuteResult(ControllerContext context)
        {
            context.HttpContext.Response.StatusCode = 500;
            context.HttpContext.Response.TrySkipIisCustomErrors = true;
            if(context.HttpContext.IsCustomErrorEnabled)
            {
                base.ViewName = "Error";
                base.ExecuteResult(context);
                return;
            }
            string controllerName = (string)context.RouteData.Values["controller"];
            string actionName = (string)context.RouteData.Values["action"];
            HandleErrorInfo info = new HandleErrorInfo(Exception, controllerName, actionName);
            ViewData.Model = info;

            if (String.IsNullOrEmpty(base.ViewName))
            {
                base.ViewName = "ErrorDetails";
            }
            base.ExecuteResult(context);
        }
    }
}