﻿using System;
using System.Web.Mvc;
using MvcApplication3.Code;

namespace MvcApplication3.Controllers
{
    public class HomeController : Controller
    {

        //
        // GET: /Home/
        public ActionResult Index()
        {
            return View();
        }

        public ActionResult CreateErrorOne()
        {
            throw new Exception("No attributes.");
        }

        [HandleError]
        public ActionResult CreateErrorTwo()
        {
            throw new Exception("Using HandleError Attribute.");
        }

        [HandleError(View = "MyErrorView")]
        public ActionResult CreateErrorThree()
        {
            throw new Exception("Using HandleError Attribute and MyErrorView.");
        }

        [HandleError(View = "MyErrorView", ExceptionType = typeof(NotImplementedException), Order=2)]
        [HandleError(View = "Error", Order=1)]
        public ActionResult CreateErrorFour(int id)
        {
            if(id < 0)
                throw new NotImplementedException("id < 0");
            throw new Exception("id >= 0");
        }

        public ActionResult CreateErrorWithErrorViewResult()
        {
            try
            {
                throw new ApplicationException("Something bad happened.");
            }
            catch (Exception ex)
            {
                return new ErrorViewResult(ex);
            }
            return View();
        }


    }
}